// Author 		: F. de la Parra
// Date			: March, 2019

package gtransport;

public class Truck extends Vehicle{
	private String bodyType; 
	private double load;
	private String routeType;
	
	// Default constructor.
	public Truck() {
		bodyType = "";
		load = 0;
		routeType = "";
	}
	
	// Full parameter constructor.
	public Truck(String type, double tLoad, String route) {
		// At this point, for example, we can run the default constructor of
		// the 'Vehicle' base class to partially initialize a 'Truck' object.
		super();
		
		bodyType = type;
		load = tLoad;
		routeType = route;
	}
	
	// Accessor methods
	
	public String getBodyType() {
		return bodyType;
	}
	
	public double getLoad() {
		return load;
	}
	
	public String getRouteType() {
		return routeType;
	}
	
	// Mutator methods
	
	public void setBodyType(String newBodyType) {
		bodyType = newBodyType;
	}
	
	public void setLoad(double newLoad) {
		load = newLoad;
	}
	
	public void setRouteType(String newRouteType) {
		routeType = newRouteType;
	}
	
	// BEHAVIOUR METHODS
	
	// Basic methods.
	
	public String toString() {
		return super.toString();
	}

	public String toString(String newBodyType) {
		if (bodyType == newBodyType)
			return "bodyType = " + bodyType + "\n" +
				   "load = " + load + "\n" +
				   "routeType = " + routeType;
		return "Unknown body type!";
	}
	
	// Application behaviour methods.
	
	public boolean addItem(int id, Vehicle schedItem) {
		System.out.println("Adding truck " + id + " to scheduled items.");
		return true;
	}

	public boolean deleteItem(int id) {
		System.out.println("Deleting truck " + id + " from scheduled items." + id);
		return true;
	}
}